Index: /palm/trunk/SOURCE/multi_agent_system_mod.f90
===================================================================
--- /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4752)
+++ /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4753)
@@ -739,252 +732,260 @@
 !                              SIN( pi/dist_round*d_prev_target )
 !              ENDIF
-             
+
 !           ENDIF
 
 
-    END SUBROUTINE mas_agent_direction
-
-!------------------------------------------------------------------------------!
+ END SUBROUTINE mas_agent_direction
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Boundary conditions for maximum time, target reached and out of domain
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_boundary_conds( location )
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  location !< Identifier
-
-       INTEGER(iwp) ::  n   !< agent number
-       INTEGER(iwp) ::  grp !< agent group
-
-       REAL(wp) ::  dist_to_target !< distance to target
-
-       IF ( location == 'max_sim_time' )  THEN
-
-!
-!--       Delete agents that have been simulated longer than allowed
-          DO  n = 1, number_of_agents
-
-             IF ( agents(n)%age > agent_maximum_age  .AND.                     &
-                  agents(n)%agent_mask )                                       &
-             THEN
-                agents(n)%agent_mask  = .FALSE.
-                deleted_agents = deleted_agents + 1
-             ENDIF
-
-          ENDDO
-       ENDIF
-
-       IF ( location == 'target_area' )  THEN
-
-!
-!--       Delete agents that entered target region
-          DO  n = 1, number_of_agents
-             grp = agents(n)%group
-             dist_to_target = SQRT((agents(n)%x-at_x(grp))**2                  &
-                                 + (agents(n)%y-at_y(grp))**2)
-             IF ( dist_to_target < dist_target_reached ) THEN
-                agents(n)%agent_mask  = .FALSE.
-                deleted_agents = deleted_agents + 1
-             ENDIF
-
-          ENDDO
-       ENDIF
-
-    END SUBROUTINE mas_boundary_conds
-
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_boundary_conds( location )
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*) ::  location  !< Identifier
+
+    INTEGER(iwp) ::  grp  !< agent group
+    INTEGER(iwp) ::  n    !< agent number
+
+    REAL(wp) ::  dist_to_target !< distance to target
+
+    IF ( location == 'max_sim_time' )  THEN
+
+!
+!--    Delete agents that have been simulated longer than allowed
+       DO  n = 1, number_of_agents
+
+          IF ( agents(n)%age > agent_maximum_age  .AND.  agents(n)%agent_mask )  THEN
+             agents(n)%agent_mask  = .FALSE.
+             deleted_agents = deleted_agents + 1
+          ENDIF
+
+       ENDDO
+    ENDIF
+
+    IF ( location == 'target_area' )  THEN
+
+!
+!--    Delete agents that entered target region
+       DO  n = 1, number_of_agents
+          grp = agents(n)%group
+          dist_to_target = SQRT( ( agents(n)%x - at_x(grp) )**2 + ( agents(n)%y - at_y(grp) )**2 )
+          IF ( dist_to_target < dist_target_reached )  THEN
+             agents(n)%agent_mask  = .FALSE.
+             deleted_agents = deleted_agents + 1
+          ENDIF
+
+       ENDDO
+    ENDIF
+
+ END SUBROUTINE mas_boundary_conds
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Release new agents at their respective sources
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_create_agent (phase)
-
-       IMPLICIT  NONE
-
-       INTEGER(iwp) ::  alloc_size  !< relative increase of allocated memory for agents
-       INTEGER(iwp) ::  i           !< loop variable ( agent groups )
-       INTEGER(iwp) ::  ip          !< index variable along x
-       INTEGER(iwp) ::  jp          !< index variable along y
-       INTEGER(iwp) ::  loop_stride !< loop variable for initialization
-       INTEGER(iwp) ::  n           !< loop variable ( number of agents )
-       INTEGER(iwp) ::  new_size    !< new size of allocated memory for agents
-       INTEGER(iwp) ::  rn_side     !< index of agent path
-
-       INTEGER(iwp), INTENT(IN) ::  phase       !< mode of inititialization
-
-       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg) ::  local_count !< start address of new agent
-       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg) ::  local_start !< start address of new agent
-
-       LOGICAL ::  first_stride !< flag for initialization
-
-       REAL(wp) ::  pos_x       !< increment for agent position in x
-       REAL(wp) ::  pos_y       !< increment for agent position in y
-       REAL(wp) ::  rand_contr  !< dummy argument for random position
-       REAL(wp) ::  rn_side_dum !< index of agent path
-
-       TYPE(agent_type),TARGET ::  tmp_agent !< temporary agent used for initialization
-
-!
-!--    Calculate agent positions and store agent attributes, if
-!--    agent is situated on this PE
-       DO  loop_stride = 1, 2
-          first_stride = (loop_stride == 1)
-          IF ( first_stride )   THEN
-             local_count = 0           ! count number of agents
-          ELSE
-             local_count = agt_count   ! Start address of new agents
-          ENDIF
-
-          DO  i = 1, number_of_agent_groups
-
-             pos_y = ass(i)
-
-             DO WHILE ( pos_y <= asn(i) )
-
-                IF ( pos_y >= nys * dy  .AND.                                  &
-                           pos_y <  ( nyn + 1 ) * dy  )                        &
-                THEN
-
-                   pos_x = asl(i)
-
-            xloop: DO WHILE ( pos_x <= asr(i) )
-
-                      IF ( pos_x >= nxl * dx  .AND.                            &
-                                 pos_x <  ( nxr + 1) * dx )                    &
-                      THEN
-
-                         tmp_agent%agent_mask = .TRUE.
-                         tmp_agent%group         = i
-                         tmp_agent%id            = 0_idp
-                         tmp_agent%block_nr      = -1
-                         tmp_agent%path_counter  = 999 !SIZE(tmp_agent%path_x)
-                         tmp_agent%age           = 0.0_wp
-                         tmp_agent%age_m         = 0.0_wp
-                         tmp_agent%dt_sum        = 0.0_wp
-                         tmp_agent%clo           = -999.0_wp
-                         tmp_agent%energy_storage= 0.0_wp
-                         tmp_agent%ipt           = 99999.0_wp
-                         tmp_agent%clothing_temp = -999._wp      !< energy stored by agent (W)
-                         tmp_agent%actlev        = 134.6862_wp   !< metabolic + work energy of the person
-                         tmp_agent%age_years     = 35._wp        !< physical age of the person
-                         tmp_agent%weight        = 75._wp        !< total weight of the person (kg)
-                         tmp_agent%height        = 1.75_wp       !< height of the person (m)
-                         tmp_agent%work          = 134.6862_wp   !< workload of the agent (W)
-                         tmp_agent%sex           = 1             !< agents gender: 1 = male, 2 = female
-                         tmp_agent%force_x       = 0.0_wp
-                         tmp_agent%force_y       = 0.0_wp
-                         tmp_agent%origin_x      = pos_x
-                         tmp_agent%origin_y      = pos_y
-                         tmp_agent%speed_abs     = 0.0_wp
-                         tmp_agent%speed_e_x     = 0.0_wp
-                         tmp_agent%speed_e_y     = 0.0_wp
-                         tmp_agent%speed_des     = random_normal(desired_speed,&
-                                                                 des_sp_sig)
-                         tmp_agent%speed_x       = 0.0_wp
-                         tmp_agent%speed_y       = 0.0_wp
-                         tmp_agent%x             = pos_x
-                         tmp_agent%y             = pos_y
-                         tmp_agent%path_x        = -1.0_wp
-                         tmp_agent%path_y        = -1.0_wp
-                         tmp_agent%t_x           = - pi
-                         tmp_agent%t_y           = - pi
-!
-!--                      Determine the grid indices of the agent position
-                         ip = tmp_agent%x * ddx
-                         jp = tmp_agent%y * ddy
-!
-!--                      Give each agent its target
-                         IF ( a_rand_target(i) ) THEN
-!
-!--                         Agent shall receive random target just outside 
-!--                         simulated area
-                            rn_side_dum = random_function(iran_agent)
-                            rn_side     = FLOOR(4.*rn_side_dum)
-                            IF ( rn_side < 2 ) THEN
-                               IF ( rn_side == 0 ) THEN
-                                  tmp_agent%t_y = -2*dy
-                               ELSE
-                                  tmp_agent%t_y = (ny+3)*dy
-                               ENDIF
-                               tmp_agent%t_x = random_function(iran_agent) *   &
-                                               (nx+1)*dx
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_create_agent ( phase )
+
+    IMPLICIT  NONE
+
+    INTEGER(iwp) ::  alloc_size  !< relative increase of allocated memory for agents
+    INTEGER(iwp) ::  i           !< loop variable ( agent groups )
+    INTEGER(iwp) ::  ip          !< index variable along x
+    INTEGER(iwp) ::  jp          !< index variable along y
+    INTEGER(iwp) ::  loop_stride !< loop variable for initialization
+    INTEGER(iwp) ::  n           !< loop variable ( number of agents )
+    INTEGER(iwp) ::  new_size    !< new size of allocated memory for agents
+    INTEGER(iwp) ::  rn_side     !< index of agent path
+
+    INTEGER(iwp), INTENT(IN) ::  phase       !< mode of inititialization
+
+    INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg) ::  local_count !< start address of new agent
+    INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg) ::  local_start !< start address of new agent
+
+    LOGICAL ::  first_stride !< flag for initialization
+
+    REAL(wp) ::  pos_x       !< increment for agent position in x
+    REAL(wp) ::  pos_y       !< increment for agent position in y
+    REAL(wp) ::  rand_contr  !< dummy argument for random position
+    REAL(wp) ::  rn_side_dum !< index of agent path
+
+    TYPE(agent_type),TARGET ::  tmp_agent !< temporary agent used for initialization
+
+!
+!-- Calculate agent positions and store agent attributes, if agent is situated on this PE.
+    DO  loop_stride = 1, 2
+       first_stride = (loop_stride == 1)
+       IF ( first_stride )  THEN
+          local_count = 0           ! count number of agents
+       ELSE
+          local_count = agt_count   ! Start address of new agents
+       ENDIF
+
+       DO  i = 1, number_of_agent_groups
+
+          pos_y = ass(i)
+
+          DO WHILE ( pos_y <= asn(i) )
+
+             IF ( pos_y >= nys * dy  .AND.  pos_y <  ( nyn + 1 ) * dy  )  THEN
+
+                pos_x = asl(i)
+
+         xloop: DO WHILE ( pos_x <= asr(i) )
+
+                   IF ( pos_x >= nxl * dx  .AND.  pos_x <  ( nxr + 1) * dx )  THEN
+
+                      tmp_agent%agent_mask = .TRUE.
+                      tmp_agent%group         = i
+                      tmp_agent%id            = 0_idp
+                      tmp_agent%block_nr      = -1
+                      tmp_agent%path_counter  = 999 !SIZE(tmp_agent%path_x)
+                      tmp_agent%age           = 0.0_wp
+                      tmp_agent%age_m         = 0.0_wp
+                      tmp_agent%dt_sum        = 0.0_wp
+                      tmp_agent%clo           = -999.0_wp
+                      tmp_agent%energy_storage= 0.0_wp
+                      tmp_agent%ipt           = 99999.0_wp
+                      tmp_agent%clothing_temp = -999._wp      !< energy stored by agent (W)
+                      tmp_agent%actlev        = 134.6862_wp   !< metabolic + work energy of the person
+                      tmp_agent%age_years     = 35._wp        !< physical age of the person
+                      tmp_agent%weight        = 75._wp        !< total weight of the person (kg)
+                      tmp_agent%height        = 1.75_wp       !< height of the person (m)
+                      tmp_agent%work          = 134.6862_wp   !< workload of the agent (W)
+                      tmp_agent%sex           = 1             !< agents gender: 1 = male, 2 = female
+                      tmp_agent%force_x       = 0.0_wp
+                      tmp_agent%force_y       = 0.0_wp
+                      tmp_agent%origin_x      = pos_x
+                      tmp_agent%origin_y      = pos_y
+                      tmp_agent%speed_abs     = 0.0_wp
+                      tmp_agent%speed_e_x     = 0.0_wp
+                      tmp_agent%speed_e_y     = 0.0_wp
+                      tmp_agent%speed_des     = random_normal(desired_speed,des_sp_sig)
+                      tmp_agent%speed_x       = 0.0_wp
+                      tmp_agent%speed_y       = 0.0_wp
+                      tmp_agent%x             = pos_x
+                      tmp_agent%y             = pos_y
+                      tmp_agent%path_x        = -1.0_wp
+                      tmp_agent%path_y        = -1.0_wp
+                      tmp_agent%t_x           = - pi
+                      tmp_agent%t_y           = - pi
+!
+!--                   Determine the grid indices of the agent position
+                      ip = tmp_agent%x * ddx
+                      jp = tmp_agent%y * ddy
+!
+!--                   Give each agent its target
+                      IF ( a_rand_target(i) )  THEN
+!
+!--                      Agent shall receive random target just outside simulated area
+                         rn_side_dum = random_function(iran_agent)
+                         rn_side     = FLOOR( 4.*rn_side_dum )
+                         IF ( rn_side < 2 )  THEN
+                            IF ( rn_side == 0 )  THEN
+                               tmp_agent%t_y = -2 * dy
                             ELSE
-                               IF ( rn_side == 2 ) THEN
-                                  tmp_agent%t_x = -2*dx
-                               ELSE
-                                  tmp_agent%t_x = (nx+3)*dx
-                               ENDIF
-                               tmp_agent%t_y = random_function(iran_agent) *   &
-                                               (ny+1)*dy
+                               tmp_agent%t_y = ( ny + 3 ) * dy
                             ENDIF
-!
-!--                      Agent gets target of her group
+                            tmp_agent%t_x = random_function(iran_agent) * ( nx + 1 ) * dx
                          ELSE
-                            tmp_agent%t_x = at_x(i)
-                            tmp_agent%t_y = at_y(i)
+                            IF ( rn_side == 2 )  THEN
+                               tmp_agent%t_x = -2 * dx
+                            ELSE
+                               tmp_agent%t_x = ( nx + 3 ) * dx
+                            ENDIF
+                            tmp_agent%t_y = random_function(iran_agent) * ( ny + 1 ) * dy
                          ENDIF
-
-                         local_count(jp,ip) = local_count(jp,ip) + 1
-
-                         IF ( .NOT. first_stride )  THEN
-                            grid_agents(jp,ip)%agents(local_count(jp,ip))      &
-                                              = tmp_agent
-                         ENDIF
-
+!
+!--                   Agent gets target of her group
+                      ELSE
+                         tmp_agent%t_x = at_x(i)
+                         tmp_agent%t_y = at_y(i)
                       ENDIF
 
-                      pos_x = pos_x + adx(i)
-
-                   ENDDO xloop
-
-                ENDIF
-
-                pos_y = pos_y + ady(i)
-
-             ENDDO
+                      local_count(jp,ip) = local_count(jp,ip) + 1
+
+                      IF ( .NOT. first_stride )  THEN
+                         grid_agents(jp,ip)%agents(local_count(jp,ip)) = tmp_agent
+                      ENDIF
+
+                   ENDIF
+
+                   pos_x = pos_x + adx(i)
+
+                ENDDO xloop
+
+             ENDIF
+
+             pos_y = pos_y + ady(i)
 
           ENDDO
 
-!
-!--       Allocate or reallocate agents array to new size
-          IF ( first_stride )  THEN
-             DO  ip = nxlg, nxrg
-                DO  jp = nysg, nyng
-                   IF ( phase == PHASE_INIT )  THEN
-                      IF ( local_count(jp,ip) > 0 )  THEN
-                         alloc_size = MAX( INT( local_count(jp,ip) *           &
-                            ( 1.0_wp + alloc_factor_mas / 100.0_wp ) ),        &
-                            min_nr_agent )
-                      ELSE
-                         alloc_size = min_nr_agent
-                      ENDIF
-                      ALLOCATE(grid_agents(jp,ip)%agents(1:alloc_size))
-                      DO  n = 1, alloc_size
-                         grid_agents(jp,ip)%agents(n) = zero_agent
-                      ENDDO
-                   ELSEIF ( phase == PHASE_RELEASE )  THEN
-                      IF ( local_count(jp,ip) > 0 )  THEN
-                         new_size   = local_count(jp,ip) + agt_count(jp,ip)
-                         alloc_size = MAX( INT( new_size * ( 1.0_wp +          &
-                            alloc_factor_mas / 100.0_wp ) ), min_nr_agent )
-                         IF( alloc_size > SIZE( grid_agents(jp,ip)%agents) )   &
-                         THEN
-                            CALL mas_eh_realloc_agents_array(ip,jp,alloc_size)
-                         ENDIF
+       ENDDO
+
+!
+!--    Allocate or reallocate agents array to new size
+       IF ( first_stride )  THEN
+          DO  ip = nxlg, nxrg
+             DO  jp = nysg, nyng
+                IF ( phase == phase_init )  THEN
+                   IF ( local_count(jp,ip) > 0 )  THEN
+                      alloc_size = MAX( INT( local_count(jp,ip) *                                  &
+                                             ( 1.0_wp + alloc_factor_mas / 100.0_wp ) ),           &
+                                        min_nr_agent )
+                   ELSE
+                      alloc_size = min_nr_agent
+                   ENDIF
+                   ALLOCATE( grid_agents(jp,ip)%agents(1:alloc_size) )
+                   DO  n = 1, alloc_size
+                      grid_agents(jp,ip)%agents(n) = zero_agent
+                   ENDDO
+                ELSEIF ( phase == phase_release )  THEN
+                   IF ( local_count(jp,ip) > 0 )  THEN
+                      new_size   = local_count(jp,ip) + agt_count(jp,ip)
+                      alloc_size = MAX( INT( new_size *                                            &
+                                             ( 1.0_wp + alloc_factor_mas / 100.0_wp ) ),           &
+                                        min_nr_agent )
+                      IF( alloc_size > SIZE( grid_agents(jp,ip)%agents) )  THEN
+                         CALL mas_eh_realloc_agents_array(ip,jp,alloc_size)
                       ENDIF
                    ENDIF
-                ENDDO
+                ENDIF
              ENDDO
-          ENDIF
+          ENDDO
+       ENDIF
+
+    ENDDO
+
+    local_start = agt_count+1
+    agt_count   = local_count
+
+!
+!-- Calculate agent IDs
+    DO  ip = nxl, nxr
+       DO  jp = nys, nyn
+          number_of_agents = agt_count(jp,ip)
+          IF ( number_of_agents <= 0 )  CYCLE
+          agents => grid_agents(jp,ip)%agents(1:number_of_agents)
+
+          DO  n = local_start(jp,ip), number_of_agents  !only new agents
+
+             agents(n)%id = 10000_idp**2 * grid_agents(jp,ip)%id_counter + 10000_idp * jp + ip
+!
+!--          Count the number of agents that have been released before
+             grid_agents(jp,ip)%id_counter = grid_agents(jp,ip)%id_counter + 1
+
+          ENDDO
 
        ENDDO
-
-       local_start = agt_count+1
-       agt_count   = local_count
-
-!
-!--    Calculate agent IDs
+    ENDDO
+
+!
+!-- Add random fluctuation to agent positions.
+    IF ( random_start_position_agents )  THEN
        DO  ip = nxl, nxr
           DO  jp = nys, nyn
